Loading...
Searching...
No Matches
mongocxx::read_concern Class Reference

`#include <mongocxx/v_noabi/mongocxx/read_concern.hpp>`

## Description

Controls the consistency and isolation properties of data read from replica sets and sharded clusters.

Read concern can be set at the client, database, or collection level. The read concern can also be provided via connection string, and will be parsed and set on the client constructed for the URI.

See also
  - Read Concern (MongoDB Manual)

## Public Types

enum class | level
| A class to represent the read concern level for read operations. More...

## Public Member Functions

| read_concern ()=default
| Constructs a new read_concern with default acknowledge_level of k_server_default.
| read_concern (v1::read_concern rc)
| Construct with the mongocxx::v1 equivalent.
level | acknowledge_level () const
| Gets the current read concern level.
void | acknowledge_level (level rc_level)
| Sets the read concern level.
bsoncxx::v1::stdx::string_view | acknowledge_string () const
| Gets the current read concern string.
void | acknowledge_string (bsoncxx::v1::stdx::string_view rc_string)
| Sets the read concern string. Any valid read concern string (e.g. "local", "majority", "linearizable", "") may be passed in. For forward-compatibility with read concern levels introduced in the future, no validation is performed on this string.
| operator v1::read_concern () &&
| Convert to the mongocxx::v1 equivalent.
| operator v1::read_concern () const &
| Convert to the mongocxx::v1 equivalent.
bsoncxx::v_noabi::document::value | to_document () const
| Gets the document form of this read_concern.

## Related Symbols

(Note that these are not member symbols.)
bool | operator== (read_concern const &lhs, read_concern const &rhs)
| Compares two read_concern objects for (in)-equality.
bool | operator!= (read_concern const &lhs, read_concern const &rhs)
| Compares two read_concern objects for (in)-equality.

## Member Enumeration Documentation

## level

enum class mongocxx::v_noabi::read_concern::level

strong

A class to represent the read concern level for read operations.

See also
  - Read Concern Levels (MongoDB Manual)
  - Default MongoDB Read Concerns/Write Concerns (MongoDB Manual)

Enumerator
k_local | Represent read concern level "local".
k_majority | Represent read concern level "majority".
k_linearizable | Represent read concern level "linearizable".
k_server_default | Represent the server's default read concern level.
k_unknown | Represent an unknown read concern level.
k_available | Represent read concern level "available".
k_snapshot | Represent read concern level "snapshot".

## Constructor & Destructor Documentation

## read_concern() [1/2]

mongocxx::v_noabi::read_concern::read_concern | ( |  | ) |

default

Constructs a new read_concern with default acknowledge_level of k_server_default.

The k_server_default acknowledge level has an empty acknowledge_string. Queries that run with this read_concern will use the server's default read_concern instead of specifying one.

## read_concern() [2/2]

mongocxx::v_noabi::read_concern::read_concern | ( | v1::read_concern | rc | ) |

inline

Construct with the mongocxx::v1 equivalent.

## Member Function Documentation

## acknowledge_level() [1/2]

level mongocxx::v_noabi::read_concern::acknowledge_level | ( |  | ) | const

inline

Gets the current read concern level.

If this was set with acknowledge_string to anything other than "local", "majority", "linearizable", or an empty string, this will return k_unknown.

Returns
  The read concern level.

## acknowledge_level() [2/2]

void mongocxx::v_noabi::read_concern::acknowledge_level | ( | level | rc_level | ) |

Sets the read concern level.

Parameters

  rc_level | Either k_local, k_majority, k_linearizable, or k_server_default.

Exceptions

  mongocxx::v_noabi::exception | if rc_level is not k_local, k_majority, k_linearizable, or k_server_default.

## acknowledge_string() [1/2]

bsoncxx::v1::stdx::string_view mongocxx::v_noabi::read_concern::acknowledge_string | ( |  | ) | const

inline

Gets the current read concern string.

If the read concern level was set with acknowledge_level, this will return either "local", "majority", "linearizable", or an empty string for k_server_default.

Returns
  The read concern string.

## acknowledge_string() [2/2]

void mongocxx::v_noabi::read_concern::acknowledge_string | ( | bsoncxx::v1::stdx::string_view | rc_string | ) |

inline

Sets the read concern string. Any valid read concern string (e.g. "local", "majority", "linearizable", "") may be passed in. For forward-compatibility with read concern levels introduced in the future, no validation is performed on this string.

Parameters

  rc_string | The read concern string.

## operator v1::read_concern() [1/2]

mongocxx::v_noabi::read_concern::operator v1::read_concern | ( |  | ) | &&

inline explicit

Convert to the mongocxx::v1 equivalent.

Postconditions:
  - *this is in an assign-or-destroy-only state.

Warning
  Invalidates all associated views.

## operator v1::read_concern() [2/2]

mongocxx::v_noabi::read_concern::operator v1::read_concern | ( |  | ) | const &

inline explicit

Convert to the mongocxx::v1 equivalent.

## to_document()

bsoncxx::v_noabi::document::value mongocxx::v_noabi::read_concern::to_document | ( |  | ) | const

inline

Gets the document form of this read_concern.

Returns
  Document representation of this read_concern.

## Friends And Related Symbol Documentation

## operator!=

bool operator!= | ( | read_concern const & | lhs,
|  | read_concern const & | rhs )

friend

Compares two read_concern objects for (in)-equality.

## operator==

bool operator== | ( | read_concern const & | lhs,
|  | read_concern const & | rhs )

friend

Compares two read_concern objects for (in)-equality.

The documentation for this class was generated from the following file:

- mongocxx/v_noabi/mongocxx/read_concern.hpp